From bippy-d175d3acf727 Mon Sep 17 00:00:00 2001
From: Greg Kroah-Hartman <gregkh@linuxfoundation.org>
To: <linux-cve-announce@vger.kernel.org>
Reply-to: <cve@kernel.org>, <linux-kernel@vger.kernel.org>
Subject: CVE-2023-52663: ASoC: SOF: amd: Fix memory leak in amd_sof_acp_probe()

Description
===========

In the Linux kernel, the following vulnerability has been resolved:

ASoC: SOF: amd: Fix memory leak in amd_sof_acp_probe()

Driver uses kasprintf() to initialize fw_{code,data}_bin members of
struct acp_dev_data, but kfree() is never called to deallocate the
memory, which results in a memory leak.

Fix the issue by switching to devm_kasprintf(). Additionally, ensure the
allocation was successful by checking the pointer validity.

The Linux kernel CVE team has assigned CVE-2023-52663 to this issue.


Affected and fixed versions
===========================

	Issue introduced in 6.6 with commit f7da88003c53 and fixed in 6.6.23 with commit 88028c45d587
	Issue introduced in 6.6 with commit f7da88003c53 and fixed in 6.7.11 with commit be4760799c6a
	Issue introduced in 6.6 with commit f7da88003c53 and fixed in 6.8.2 with commit 7296152e5885
	Issue introduced in 6.6 with commit f7da88003c53 and fixed in 6.9 with commit 222be59e5eed

Please see https://www.kernel.org for a full list of currently supported
kernel versions by the kernel community.

Unaffected versions might change over time as fixes are backported to
older supported kernel versions.  The official CVE entry at
	https://cve.org/CVERecord/?id=CVE-2023-52663
will be updated if fixes are backported, please check that for the most
up to date information about this issue.


Affected files
==============

The file(s) affected by this issue are:
	sound/soc/sof/amd/acp.c


Mitigation
==========

The Linux kernel CVE team recommends that you update to the latest
stable kernel version for this, and many other bugfixes.  Individual
changes are never tested alone, but rather are part of a larger kernel
release.  Cherry-picking individual commits is not recommended or
supported by the Linux kernel community at all.  If however, updating to
the latest release is impossible, the individual changes to resolve this
issue can be found at these commits:
	https://git.kernel.org/stable/c/88028c45d5871dfc449b2b0a27abf6428453a5ec
	https://git.kernel.org/stable/c/be4760799c6a7c01184467287f0de41e0dd255f8
	https://git.kernel.org/stable/c/7296152e58858f928db448826eb7ba5ae611297b
	https://git.kernel.org/stable/c/222be59e5eed1554119294edc743ee548c2371d0
